package com.jenny.advancedarrows.entities;

import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.Vec3;
import org.jetbrains.annotations.NotNull;

public class baseArrow extends AbstractArrow {
    private final Item itemPickup;
    private int tick = 0;

    public baseArrow(EntityType<? extends baseArrow> pEntityType, Level pLevel, Item item) {
        super(pEntityType, pLevel, item.getDefaultInstance());
        this.itemPickup = item;
    }

    public baseArrow(Level pLevel, LivingEntity pShooter, EntityType<? extends baseArrow> pEntityType, Item item) {
        super(pEntityType, pShooter, pLevel, item.getDefaultInstance());
        this.itemPickup = item;
    }

    public void tick() {
        super.tick();
        if (this.level().isClientSide) {
            if (!this.inGround) {
                spawnParticles();
            }
            this.tick++;
        } else if (this.inGround && this.inGroundTime != 0 && this.inGroundTime >= 600) {
            this.level().broadcastEntityEvent(this, (byte)0);
        }
    }

    @NotNull
    protected ItemStack getPickupItem() {
        System.out.println(itemPickup.toString());
        return itemPickup.getDefaultInstance();
    }

    public void handleEntityEvent(byte pId) {
        if (pId == 0) {
            int i = -1;
            if (i != -1) {
                double d0 = (double)(i >> 16 & 255) / 255.0D;
                double d1 = (double)(i >> 8 & 255) / 255.0D;
                double d2 = (double)(i >> 0 & 255) / 255.0D;

                for(int j = 0; j < 20; ++j) {
                    this.level().addParticle(ParticleTypes.ENTITY_EFFECT, this.getRandomX(0.5D), this.getRandomY(), this.getRandomZ(0.5D), d0, d1, d2);
                }
            }
        } else {
            super.handleEntityEvent(pId);
        }

    }

    public Vec3 createParticlePos(float range) {
        return new Vec3(
                (double) level().getRandom().nextIntBetweenInclusive(-100, 100) / 100,
                (double) level().getRandom().nextIntBetweenInclusive(-100, 100) / 100,
                (double) level().getRandom().nextIntBetweenInclusive(-100, 100) / 100
        ).normalize().scale(range).add(position());
    }

    public Vec3 createParticlePos(Entity entity, float range) {
        return new Vec3(
                (double) level().getRandom().nextIntBetweenInclusive(-100, 100) / 100,
                (double) level().getRandom().nextIntBetweenInclusive(-100, 100) / 100,
                (double) level().getRandom().nextIntBetweenInclusive(-100, 100) / 100
        ).normalize().scale(range).add(entity.position());
    }

    public void spawnParticles() {
    }

    public int getTick() {
        return this.tick;
    }
}
