package com.jenny.advancedarrows.entities;

import com.jenny.advancedarrows.entities.client.baseArrowRenderer;
import net.minecraft.client.renderer.entity.EntityRenderers;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.MobCategory;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.RegistryObject;

import static com.jenny.advancedarrows.advancedArrows.MODID;

public class entities {
    private static final int tr = 32;
    private static final float w = 0.5f;
    private static final float h = 0.5f;

    public static final DeferredRegister<EntityType<?>> ENTITY_TYPES =
            DeferredRegister.create(ForgeRegistries.ENTITY_TYPES, MODID);

    public static final RegistryObject<EntityType<incendiaryArrow>> ARROW_INCENDIARY =
            ENTITY_TYPES.register("arrow_incendiary", () -> EntityType.Builder.<incendiaryArrow>of(incendiaryArrow::new, MobCategory.MISC)
                    .sized(w, h).fireImmune().clientTrackingRange(tr).build("arrow_incendiary"));

    public static final RegistryObject<EntityType<ricochetArrow>> ARROW_RICOCHET =
            ENTITY_TYPES.register("arrow_ricochet", () -> EntityType.Builder.<ricochetArrow>of(ricochetArrow::new, MobCategory.MISC)
                    .sized(w, h).fireImmune().clientTrackingRange(tr).build("arrow_ricochet"));

    public static final RegistryObject<EntityType<kineticArrow>> ARROW_KINETIC =
            ENTITY_TYPES.register("arrow_kinetic", () -> EntityType.Builder.<kineticArrow>of(kineticArrow::new, MobCategory.MISC)
                    .sized(w, h).fireImmune().clientTrackingRange(tr).build("arrow_kinetic"));

    public static final RegistryObject<EntityType<sharpenedArrow>> ARROW_SHARPENED =
            ENTITY_TYPES.register("arrow_sharpened", () -> EntityType.Builder.<sharpenedArrow>of(sharpenedArrow::new, MobCategory.MISC)
                    .sized(w, h).fireImmune().clientTrackingRange(tr).build("arrow_sharpened"));

    public static final RegistryObject<EntityType<switchArrow>> ARROW_SWITCH =
            ENTITY_TYPES.register("arrow_switch", () -> EntityType.Builder.<switchArrow>of(switchArrow::new, MobCategory.MISC)
                    .sized(w, h).fireImmune().clientTrackingRange(tr).build("arrow_switch"));

    public static final RegistryObject<EntityType<breachingArrow>> ARROW_BREACHING =
            ENTITY_TYPES.register("arrow_breaching", () -> EntityType.Builder.<breachingArrow>of(breachingArrow::new, MobCategory.MISC)
                    .sized(w, h).fireImmune().clientTrackingRange(tr).build("arrow_breaching"));

    public static final RegistryObject<EntityType<homingArrow>> ARROW_HOMING =
            ENTITY_TYPES.register("arrow_homing", () -> EntityType.Builder.<homingArrow>of(homingArrow::new, MobCategory.MISC)
                    .sized(w, h).fireImmune().clientTrackingRange(tr).build("arrow_homing"));

    public static final RegistryObject<EntityType<enderArrow>> ARROW_ENDER =
            ENTITY_TYPES.register("arrow_ender", () -> EntityType.Builder.<enderArrow>of(enderArrow::new, MobCategory.MISC)
                    .sized(w, h).fireImmune().clientTrackingRange(tr).build("arrow_ender"));

    public static void register(IEventBus eventBus) {
        ENTITY_TYPES.register(eventBus);
    }

    public static void registerRenderers () {
        EntityRenderers.register(ARROW_INCENDIARY.get(), baseArrowRenderer::new);
        EntityRenderers.register(ARROW_RICOCHET.get(), baseArrowRenderer::new);
        EntityRenderers.register(ARROW_KINETIC.get(), baseArrowRenderer::new);
        EntityRenderers.register(ARROW_SHARPENED.get(), baseArrowRenderer::new);
        EntityRenderers.register(ARROW_SWITCH.get(), baseArrowRenderer::new);
        EntityRenderers.register(ARROW_BREACHING.get(), baseArrowRenderer::new);
        EntityRenderers.register(ARROW_HOMING.get(), baseArrowRenderer::new);
        EntityRenderers.register(ARROW_ENDER.get(), baseArrowRenderer::new);
    }
}
